# generated by datamodel-codegen:
#   filename:  lookalike_media_request.json

from __future__ import annotations

from enum import Enum
from typing import Optional, Sequence, Union

from pydantic import BaseModel, Extra, Field, conint


class RetrieveDataRoom(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str


class LookalikeMediaRequestItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    retrieveDataRoom: RetrieveDataRoom


class PublishAdvertiserDataset(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str
    datasetHashHex: str
    encryptionKeyHex: str
    scopeIdHex: str


class LookalikeMediaRequestItem2(BaseModel):
    class Config:
        extra = Extra.forbid

    publishAdvertiserDataset: PublishAdvertiserDataset


class PublishPublisherUsersDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem3(BaseModel):
    class Config:
        extra = Extra.forbid

    publishPublisherUsersDataset: PublishPublisherUsersDataset


class UnpublishAdvertiserDataset(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem4(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishAdvertiserDataset: UnpublishAdvertiserDataset


class RetrievePublishedDatasets(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem5(BaseModel):
    class Config:
        extra = Extra.forbid

    retrievePublishedDatasets: RetrievePublishedDatasets


class CalculateOverlapBasic(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str
    scopeIdHex: str


class LookalikeMediaRequestItem6(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateOverlapBasic: CalculateOverlapBasic


class CalculateOverlapInsights(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem7(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateOverlapInsights: CalculateOverlapInsights


class PublishDemographicsDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem8(BaseModel):
    class Config:
        extra = Extra.forbid

    publishDemographicsDataset: PublishDemographicsDataset


class PublishSegmentsDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem9(BaseModel):
    class Config:
        extra = Extra.forbid

    publishSegmentsDataset: PublishSegmentsDataset


class PublishEmbeddingsDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem10(BaseModel):
    class Config:
        extra = Extra.forbid

    publishEmbeddingsDataset: PublishEmbeddingsDataset


class PublishActivatedAudiencesConfig(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem11(BaseModel):
    class Config:
        extra = Extra.forbid

    publishActivatedAudiencesConfig: PublishActivatedAudiencesConfig


class UnpublishActivatedAudiencesConfig(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem12(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishActivatedAudiencesConfig: UnpublishActivatedAudiencesConfig


class CalculateModelledAudienceInsights(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem13(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateModelledAudienceInsights: CalculateModelledAudienceInsights


class CalculateModelledAudienceInsightsView(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem14(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateModelledAudienceInsightsView: CalculateModelledAudienceInsightsView


class ComputeAudienceSizes(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem15(BaseModel):
    class Config:
        extra = Extra.forbid

    computeAudienceSizes: ComputeAudienceSizes


class ViewPublishedActivatedAudiences(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem17(BaseModel):
    class Config:
        extra = Extra.forbid

    viewPublishedActivatedAudiences: ViewPublishedActivatedAudiences


class ViewActivatedAudiences(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem18(BaseModel):
    class Config:
        extra = Extra.forbid

    viewActivatedAudiences: ViewActivatedAudiences


class IngestAudiencesReport(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem19(BaseModel):
    class Config:
        extra = Extra.forbid

    ingestAudiencesReport: IngestAudiencesReport


class EnclaveSpecificationV01(BaseModel):
    attestationProtoBase64: str
    id: str
    workerProtocol: conint(ge=0)


class FormatType1(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm1(Enum):
    SHA256_HEX = 'SHA256_HEX'


class LookalikeMediaDataRoomV0(BaseModel):
    advertiserEmails: Sequence[str]
    agencyEmails: Sequence[str]
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecificationV01
    enableAuditLogRetrieval: bool
    enableDevComputations: bool
    enableDownloadByAdvertiser: bool
    enableDownloadByAgency: bool
    enableDownloadByPublisher: bool
    enableOverlapInsights: bool
    hashMatchingIdWith: Optional[Optional[HashingAlgorithm1]] = None
    id: str
    mainAdvertiserEmail: str
    mainPublisherEmail: str
    matchingIdFormat: FormatType1
    name: str
    observerEmails: Sequence[str]
    publisherEmails: Sequence[str]
    pythonEnclaveSpecification: EnclaveSpecificationV01


class LookalikeMediaDataRoomV1(LookalikeMediaDataRoomV0):
    pass


class LookalikeMediaDataRoomV2(LookalikeMediaDataRoomV0):
    pass


class LookalikeMediaDcrComputeV0(BaseModel):
    advertiserEmails: Sequence[str]
    agencyEmails: Sequence[str]
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecificationV01
    hashMatchingIdWith: Optional[Optional[HashingAlgorithm1]] = None
    id: str
    mainAdvertiserEmail: str
    mainPublisherEmail: str
    matchingIdFormat: FormatType1
    name: str
    observerEmails: Sequence[str]
    publisherEmails: Sequence[str]
    pythonEnclaveSpecification: EnclaveSpecificationV01


class RequestedAudiencePayload(BaseModel):
    class Config:
        extra = Extra.forbid

    audienceType: str
    reach: float


class Type6(Enum):
    SUPPORTED = 'SUPPORTED'


class RequirementFlagValueItem6(BaseModel):
    type: Type6


class Type7(Enum):
    DATASET = 'DATASET'


class RequirementFlagValueItem7(BaseModel):
    type: Type7


class Type8(Enum):
    PROPERTY = 'PROPERTY'


class RequirementFlagValueItem8(BaseModel):
    type: Type8
    value: str


class RequirementFlagValue(BaseModel):
    __root__: Union[
        RequirementFlagValueItem6, RequirementFlagValueItem7, RequirementFlagValueItem8
    ]


class GetLookalikeAudience(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str
    requestedAudience: RequestedAudiencePayload
    scopeIdHex: str


class LookalikeMediaRequestItem16(BaseModel):
    class Config:
        extra = Extra.forbid

    getLookalikeAudience: GetLookalikeAudience


class KnownOrUnknownRequirementFlagValue2(BaseModel):
    __root__: Optional[RequirementFlagValue]


class LookalikeMediaDataRoomItem4(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: LookalikeMediaDataRoomV0


class LookalikeMediaDataRoomItem5(BaseModel):
    class Config:
        extra = Extra.forbid

    v1: LookalikeMediaDataRoomV1


class LookalikeMediaDataRoomItem6(BaseModel):
    class Config:
        extra = Extra.forbid

    v2: LookalikeMediaDataRoomV2


class LookalikeMediaDcrComputeItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: LookalikeMediaDcrComputeV0


class LookalikeMediaDcrCompute1(BaseModel):
    __root__: LookalikeMediaDcrComputeItem1


class LookalikeMediaDcrComputeOrUnknown1(BaseModel):
    __root__: Optional[LookalikeMediaDcrCompute1]


class RequirementFlag2(BaseModel):
    details: KnownOrUnknownRequirementFlagValue2
    name: str


class Requirements(BaseModel):
    optional: Sequence[RequirementFlag2]
    required: Sequence[RequirementFlag2]


class LookalikeMediaDcrWrapper(BaseModel):
    compute: LookalikeMediaDcrComputeOrUnknown1
    consumes: Requirements
    features: Sequence[str]


class LookalikeMediaDataRoomItem7(BaseModel):
    class Config:
        extra = Extra.forbid

    v4: LookalikeMediaDcrWrapper


class LookalikeMediaDataRoom(BaseModel):
    __root__: Union[
        LookalikeMediaDataRoomItem4,
        LookalikeMediaDataRoomItem5,
        LookalikeMediaDataRoomItem6,
        LookalikeMediaDataRoomItem7,
    ] = Field(
        ...,
        description='The high-level representation of an LMDCR. Starting with version 4, an outer structure has been introduced that exposes the "features" supported by the LMDCR via string-based flags. This way, every version of DDC can extract these feature flags and inform the SDKs whether a particular function is supported by this LMDCR. In a similar way, the LMDCR exposes what datasets it needs as input from a DataLab such that we can check the compatibility between a DataLab and a LMDCR from any version of DDC/the SDKs.',
    )


class PublishDataRoom(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoom: LookalikeMediaDataRoom
    requirePassword: bool
    showOrganizationLogo: bool


class LookalikeMediaRequestItem(BaseModel):
    class Config:
        extra = Extra.forbid

    publishDataRoom: PublishDataRoom


class LookalikeMediaRequest(BaseModel):
    __root__: Union[
        LookalikeMediaRequestItem,
        LookalikeMediaRequestItem1,
        LookalikeMediaRequestItem2,
        LookalikeMediaRequestItem3,
        LookalikeMediaRequestItem4,
        LookalikeMediaRequestItem5,
        LookalikeMediaRequestItem6,
        LookalikeMediaRequestItem7,
        LookalikeMediaRequestItem8,
        LookalikeMediaRequestItem9,
        LookalikeMediaRequestItem10,
        LookalikeMediaRequestItem11,
        LookalikeMediaRequestItem12,
        LookalikeMediaRequestItem13,
        LookalikeMediaRequestItem14,
        LookalikeMediaRequestItem15,
        LookalikeMediaRequestItem16,
        LookalikeMediaRequestItem17,
        LookalikeMediaRequestItem18,
        LookalikeMediaRequestItem19,
    ] = Field(
        ..., description='MediaRequest -> GcgRequest', title='LookalikeMediaRequest'
    )
